import { ArrayFilterPredicateType } from './Types';
export declare class ArrayStore<T> {
    private _items;
    private readonly _defaultValue;
    constructor(items?: Array<T>);
    get isDefault(): boolean;
    get items(): Array<T>;
    get count(): number;
    get isEmpty(): boolean;
    get first(): T | undefined;
    get last(): T | undefined;
    add(...item: Array<T>): this;
    at(index: number): T;
    setItems(items: Array<T>): this;
    insert(index: number, item: T): this;
    remove(item: T): boolean;
    removeAt(index: number): boolean;
    filter(predicate: (value: T) => boolean): this;
    splice(index: number, count: number): this;
    some(item: T): boolean;
    find(predicate: (this: void, value: T, index: number, obj: Array<T>) => unknown, thisArg?: any): T | undefined;
    findIndex(predicate: ArrayFilterPredicateType<T>, thisArg?: any): number;
    updateByIndex(index: number, value: T): this;
    update(predicate: ArrayFilterPredicateType<T>, value: T): this;
    reset(): this;
    clear(): this;
    toggle(item: T): this;
}
