import { AsyncOperationStoreOptions } from './AsyncOperationStoreOptions';
import { OperationStateStore } from '../OperationState';
export declare class AsyncOperationStore<P = undefined, R = void> {
    readonly state: OperationStateStore;
    private readonly _options;
    private readonly _error;
    private readonly _operation;
    private readonly _result;
    private _resultPromise;
    private _params;
    constructor(operation: (params: P) => Promise<R>, options?: Partial<AsyncOperationStoreOptions>);
    get error(): Error;
    get result(): R;
    execute(params: P): Promise<R>;
    private normalizeError;
    private run;
    abort(): Promise<void>;
    reset(): void;
}
