var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { action, computed, observable } from 'mobx';
let NumericStore = /** @class */ (() => {
    class NumericStore {
        constructor(value, options = {}) {
            this.add = this.add.bind(this);
            this.subtract = this.subtract.bind(this);
            this.multiply = this.multiply.bind(this);
            this.divide = this.divide.bind(this);
            this.increment = this.increment.bind(this);
            this.decrement = this.decrement.bind(this);
            this.set = this.set.bind(this);
            this._value = value;
            this._defaultValue = options?.defaultValue === undefined
                ? value
                : options.defaultValue;
        }
        get value() {
            return this._value;
        }
        get isDefault() {
            return this._value === this._defaultValue;
        }
        get isNegative() {
            return this.value < 0;
        }
        get isPositive() {
            return this.value > 0;
        }
        get isZero() {
            return this.value === 0;
        }
        add(value) {
            this._value = this._value + value;
            return this;
        }
        subtract(value) {
            this._value = this._value - value;
            return this;
        }
        multiply(value) {
            this._value = this._value * value;
            return this;
        }
        divide(value) {
            this._value = this._value / value;
            return this;
        }
        increment() {
            this._value = this._value + 1;
            return this;
        }
        decrement() {
            this._value = this._value - 1;
            return this;
        }
        set(value) {
            this._value = value;
            return this;
        }
        reset() {
            this._value = this._defaultValue;
            return this;
        }
    }
    __decorate([
        observable
    ], NumericStore.prototype, "_value", void 0);
    __decorate([
        observable
    ], NumericStore.prototype, "_defaultValue", void 0);
    __decorate([
        computed
    ], NumericStore.prototype, "value", null);
    __decorate([
        computed
    ], NumericStore.prototype, "isDefault", null);
    __decorate([
        computed
    ], NumericStore.prototype, "isNegative", null);
    __decorate([
        computed
    ], NumericStore.prototype, "isPositive", null);
    __decorate([
        computed
    ], NumericStore.prototype, "isZero", null);
    __decorate([
        action
    ], NumericStore.prototype, "add", null);
    __decorate([
        action
    ], NumericStore.prototype, "subtract", null);
    __decorate([
        action
    ], NumericStore.prototype, "multiply", null);
    __decorate([
        action
    ], NumericStore.prototype, "divide", null);
    __decorate([
        action
    ], NumericStore.prototype, "increment", null);
    __decorate([
        action
    ], NumericStore.prototype, "decrement", null);
    __decorate([
        action
    ], NumericStore.prototype, "set", null);
    __decorate([
        action
    ], NumericStore.prototype, "reset", null);
    return NumericStore;
})();
export { NumericStore };
//# sourceMappingURL=NumericStore.js.map