var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { action, computed, observable } from 'mobx';
let ObjectStore = /** @class */ (() => {
    class ObjectStore {
        constructor(value = undefined, options = {}) {
            this.set = this.set.bind(this);
            this.reset = this.reset.bind(this);
            this.change = this.change.bind(this);
            this._value = value;
            this._defaultValue = options?.defaultValue;
        }
        get value() {
            return this._value;
        }
        get isDefault() {
            return this._value === this._defaultValue;
        }
        set(value) {
            this._value = value;
        }
        reset() {
            this.set(this._defaultValue);
        }
        change(key, value) {
            this._value[key] = value;
            return this;
        }
    }
    __decorate([
        observable
    ], ObjectStore.prototype, "_value", void 0);
    __decorate([
        computed
    ], ObjectStore.prototype, "value", null);
    __decorate([
        computed
    ], ObjectStore.prototype, "isDefault", null);
    __decorate([
        action
    ], ObjectStore.prototype, "set", null);
    __decorate([
        action
    ], ObjectStore.prototype, "reset", null);
    __decorate([
        action
    ], ObjectStore.prototype, "change", null);
    return ObjectStore;
})();
export { ObjectStore };
//# sourceMappingURL=ObjectStore.js.map