var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { action, computed, observable } from 'mobx';
import { OperationState } from './OperationState';
let OperationStateStore = /** @class */ (() => {
    class OperationStateStore {
        constructor() {
            this._status = OperationState.Idle;
            this.idle = this.idle.bind(this);
            this.start = this.start.bind(this);
            this.done = this.done.bind(this);
            this.abort = this.abort.bind(this);
            this.fail = this.fail.bind(this);
        }
        get status() {
            return this._status;
        }
        get isIdle() {
            return this._status === OperationState.Idle;
        }
        get isRunning() {
            return this._status === OperationState.Running;
        }
        get isPaused() {
            return this._status === OperationState.Paused;
        }
        get isDone() {
            return this._status === OperationState.Done;
        }
        get isAborted() {
            return this._status === OperationState.Aborted;
        }
        get isFailed() {
            return this._status === OperationState.Failed;
        }
        get isCompleted() {
            return [
                OperationState.Done,
                OperationState.Aborted,
                OperationState.Failed
            ].includes(this._status);
        }
        get isNotCompleted() {
            return !this.isCompleted;
        }
        idle() {
            this._status = OperationState.Idle;
        }
        start() {
            this._status = OperationState.Running;
        }
        pause() {
            this._status = OperationState.Paused;
        }
        done() {
            this._status = OperationState.Done;
        }
        abort() {
            this._status = OperationState.Aborted;
        }
        fail() {
            this._status = OperationState.Failed;
        }
        get current() {
            return {
                isIdle: this.isIdle,
                isRunning: this.isRunning,
                isPaused: this.isPaused,
                isDone: this.isDone,
                isAborted: this.isAborted,
                isFailed: this.isFailed,
            };
        }
    }
    __decorate([
        observable
    ], OperationStateStore.prototype, "_status", void 0);
    __decorate([
        computed
    ], OperationStateStore.prototype, "status", null);
    __decorate([
        computed
    ], OperationStateStore.prototype, "isIdle", null);
    __decorate([
        computed
    ], OperationStateStore.prototype, "isRunning", null);
    __decorate([
        computed
    ], OperationStateStore.prototype, "isPaused", null);
    __decorate([
        computed
    ], OperationStateStore.prototype, "isDone", null);
    __decorate([
        computed
    ], OperationStateStore.prototype, "isAborted", null);
    __decorate([
        computed
    ], OperationStateStore.prototype, "isFailed", null);
    __decorate([
        computed
    ], OperationStateStore.prototype, "isCompleted", null);
    __decorate([
        computed
    ], OperationStateStore.prototype, "isNotCompleted", null);
    __decorate([
        action
    ], OperationStateStore.prototype, "idle", null);
    __decorate([
        action
    ], OperationStateStore.prototype, "start", null);
    __decorate([
        action
    ], OperationStateStore.prototype, "pause", null);
    __decorate([
        action
    ], OperationStateStore.prototype, "done", null);
    __decorate([
        action
    ], OperationStateStore.prototype, "abort", null);
    __decorate([
        action
    ], OperationStateStore.prototype, "fail", null);
    __decorate([
        computed
    ], OperationStateStore.prototype, "current", null);
    return OperationStateStore;
})();
export { OperationStateStore };
//# sourceMappingURL=OperationStateStore.js.map