import { ArrayStore } from '../Array';
import { SelectionStoreOptions } from './SelectionStoreOptions';
export declare class SelectionStore<T> {
    private readonly _canSelect;
    readonly list: ArrayStore<T>;
    readonly selected: ArrayStore<T>;
    constructor(options: SelectionStoreOptions<T>);
    get isFull(): boolean;
    get isPartial(): boolean;
    get isEmpty(): boolean;
    selectAll(): this;
    clear(): this;
    selectOne(item: T): this;
    select(item: T): this;
    toggle(item: T): this;
    toggleAll(): this;
    isSelected(item: T): boolean;
    isSelectable(item: T): boolean;
}
