var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { computed } from 'mobx';
import { ArrayStore } from '../Array';
let SelectionStore = /** @class */ (() => {
    class SelectionStore {
        constructor(options) {
            this.list = new ArrayStore();
            this.selected = new ArrayStore();
            this.selectAll = this.selectAll.bind(this);
            this.clear = this.clear.bind(this);
            this.toggle = this.toggle.bind(this);
            this.toggleAll = this.toggleAll.bind(this);
            this.isSelected = this.isSelected.bind(this);
            this.selectOne = this.selectOne.bind(this);
            this.list = options.list;
            this._canSelect = options.canSelect || (() => true);
        }
        get isFull() {
            return this.list.count === this.selected.count;
        }
        get isPartial() {
            return (!this.isEmpty
                && this.list.count !== this.selected.count);
        }
        get isEmpty() {
            return this.selected.isEmpty;
        }
        selectAll() {
            this.selected.setItems(this.list.items.filter(this._canSelect));
            return this;
        }
        clear() {
            this.selected.clear();
            return this;
        }
        selectOne(item) {
            this.clear();
            this.selected.add(item);
            return this;
        }
        select(item) {
            if (this.isSelectable(item)) {
                // TODO check uniqueness
                this.selected.add(item);
            }
            return this;
        }
        toggle(item) {
            if (this._canSelect(item)) {
                this.selected.toggle(item);
            }
            return this;
        }
        toggleAll() {
            this.isEmpty
                ? this.selectAll()
                : this.selected.clear();
            return this;
        }
        isSelected(item) {
            return this.selected.some(item);
        }
        isSelectable(item) {
            return this._canSelect(item);
        }
    }
    __decorate([
        computed
    ], SelectionStore.prototype, "isFull", null);
    __decorate([
        computed
    ], SelectionStore.prototype, "isPartial", null);
    __decorate([
        computed
    ], SelectionStore.prototype, "isEmpty", null);
    return SelectionStore;
})();
export { SelectionStore };
//# sourceMappingURL=SelectionStore.js.map