var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { action, computed, observable } from 'mobx';
let StringStore = /** @class */ (() => {
    class StringStore {
        constructor(value = '') {
            this.concat = this.concat.bind(this);
            this.substr = this.substr.bind(this);
            this.substring = this.substring.bind(this);
            this.trim = this.trim.bind(this);
            this.trimLeft = this.trimLeft.bind(this);
            this.trimRight = this.trimRight.bind(this);
            this.toLowerCase = this.toLowerCase.bind(this);
            this.toUpperCase = this.toUpperCase.bind(this);
            this.set = this.set.bind(this);
            this.reset = this.reset.bind(this);
            this._defaultValue = value;
            this._value = value;
        }
        get isDefault() {
            return this._value === this._defaultValue;
        }
        get value() {
            return this._value;
        }
        concat(value) {
            this._value = this._value + value;
            return this;
        }
        substr(from, length) {
            this._value = this._value.substr(from, length);
            return this;
        }
        substring(start, end) {
            this._value = this._value.substring(start, end);
            return this;
        }
        trim() {
            this._value = this._value.trim();
            return this;
        }
        trimLeft() {
            this._value = this._value.trimLeft();
            return this;
        }
        trimRight() {
            this._value = this._value.trimRight();
            return this;
        }
        toLowerCase() {
            this._value = this._value.toLowerCase();
            return this;
        }
        toUpperCase() {
            this._value = this._value.toUpperCase();
            return this;
        }
        set(value) {
            this._value = value;
            return this;
        }
        reset() {
            this._value = this._defaultValue;
            return this;
        }
    }
    __decorate([
        observable
    ], StringStore.prototype, "_value", void 0);
    __decorate([
        computed
    ], StringStore.prototype, "isDefault", null);
    __decorate([
        computed
    ], StringStore.prototype, "value", null);
    __decorate([
        action
    ], StringStore.prototype, "concat", null);
    __decorate([
        action
    ], StringStore.prototype, "substr", null);
    __decorate([
        action
    ], StringStore.prototype, "substring", null);
    __decorate([
        action
    ], StringStore.prototype, "trim", null);
    __decorate([
        action
    ], StringStore.prototype, "trimLeft", null);
    __decorate([
        action
    ], StringStore.prototype, "trimRight", null);
    __decorate([
        action
    ], StringStore.prototype, "toLowerCase", null);
    __decorate([
        action
    ], StringStore.prototype, "toUpperCase", null);
    __decorate([
        action
    ], StringStore.prototype, "set", null);
    __decorate([
        action
    ], StringStore.prototype, "reset", null);
    return StringStore;
})();
export { StringStore };
//# sourceMappingURL=StringStore.js.map