import { NumberOfMilliseconds } from '../Types';
import { TimerStoreOptions } from './TimerStoreOptions';
import { AsyncOperationStore } from '@src/AsyncOperation';
export declare class TimerStore {
    private readonly _timeout;
    private readonly _operation;
    private readonly _timer;
    private readonly _options;
    private _startedAt;
    private _doneAt;
    private _canceledAt;
    constructor(operation: AsyncOperationStore<void>, timout: NumberOfMilliseconds, options?: Partial<TimerStoreOptions>);
    get startedAt(): number;
    get doneAt(): number;
    get canceledAt(): number;
    get isStarted(): boolean;
    get isDone(): boolean;
    get isCanceled(): boolean;
    get isRunning(): boolean;
    start(): Promise<void>;
    private scheduleNextLoop;
    cancel(): Promise<void>;
    private clearInterval;
    stop(): Promise<void>;
}
