var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { computed } from 'mobx';
import { ValueStore } from '../Value';
let ToggleStateStore = /** @class */ (() => {
    class ToggleStateStore {
        constructor(state = 'off') {
            this._state = new ValueStore(state);
            this.on = this.on.bind(this);
            this.off = this.off.bind(this);
            this.toggle = this.toggle.bind(this);
            this.indeterminate = this.indeterminate.bind(this);
        }
        get isOn() {
            return this._state.value === 'on';
        }
        get isOff() {
            return this._state.value === 'off';
        }
        get isIndeterminate() {
            return this._state.value === 'indeterminate';
        }
        toggle() {
            const value = this._state.value === 'on' ? 'off' : 'on';
            this._state.set(value);
        }
        on() {
            this._state.set('on');
        }
        off() {
            this._state.set('off');
        }
        indeterminate() {
            this._state.set('indeterminate');
        }
    }
    __decorate([
        computed
    ], ToggleStateStore.prototype, "isOn", null);
    __decorate([
        computed
    ], ToggleStateStore.prototype, "isOff", null);
    __decorate([
        computed
    ], ToggleStateStore.prototype, "isIndeterminate", null);
    return ToggleStateStore;
})();
export { ToggleStateStore };
//# sourceMappingURL=ToggleStateStore.js.map