/// <reference types="node" />
import { ValueStoreOptions } from './ValueStoreOptions';
declare type ScalarValue = string | number | boolean | Date | NodeJS.Timer | null | unknown | void;
export declare class ValueStore<T extends ScalarValue> {
    private _defaultValue;
    private _value;
    constructor(value?: T, options?: ValueStoreOptions<T>);
    get value(): T;
    get isDefault(): boolean;
    set(value: T): void;
    reset(): void;
    is(value: T): boolean;
}
export {};
