var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { action, computed, observable } from 'mobx';
let VisibilityStore = /** @class */ (() => {
    class VisibilityStore {
        constructor(isVisible = false) {
            this._isVisible = false;
            this.show = this.show.bind(this);
            this.hide = this.hide.bind(this);
            this.toggle = this.toggle.bind(this);
            isVisible
                ? this.show()
                : this.hide();
        }
        get isHidden() {
            return !this._isVisible;
        }
        get isVisible() {
            return this._isVisible;
        }
        show() {
            this._isVisible = true;
        }
        hide() {
            this._isVisible = false;
        }
        toggle() {
            this._isVisible = !this._isVisible;
        }
    }
    __decorate([
        observable
    ], VisibilityStore.prototype, "_isVisible", void 0);
    __decorate([
        computed
    ], VisibilityStore.prototype, "isHidden", null);
    __decorate([
        computed
    ], VisibilityStore.prototype, "isVisible", null);
    __decorate([
        action
    ], VisibilityStore.prototype, "show", null);
    __decorate([
        action
    ], VisibilityStore.prototype, "hide", null);
    __decorate([
        action
    ], VisibilityStore.prototype, "toggle", null);
    return VisibilityStore;
})();
export { VisibilityStore };
//# sourceMappingURL=VisibilityStore.js.map